diff --git a/src/gui/kernel/qguiapplication.cpp b/src/gui/kernel/qguiapplication.cpp
index 190d527..7fd343c 100644
--- a/src/gui/kernel/qguiapplication.cpp
+++ b/src/gui/kernel/qguiapplication.cpp
@@ -1518,6 +1518,9 @@ void QGuiApplicationPrivate::processKeyEvent(QWindowSystemInterfacePrivate::KeyE
                  e->nativeScanCode, e->nativeVirtualKey, e->nativeModifiers,
                  e->unicode, e->repeat, e->repeatCount);
     ev.setTimestamp(e->timestamp);
+    if (ev.key() == 67) {
+        qDebug() << Q_FUNC_INFO << window << ev.key();
+    }
     QGuiApplication::sendSpontaneousEvent(window, &ev);
 }
 
diff --git a/src/widgets/kernel/qapplication.cpp b/src/widgets/kernel/qapplication.cpp
index ed6262c..f122f3f 100644
--- a/src/widgets/kernel/qapplication.cpp
+++ b/src/widgets/kernel/qapplication.cpp
@@ -3379,6 +3379,10 @@ bool QApplicationPrivate::notify_helper(QObject *receiver, QEvent * e)
         if (QLayout *layout=widget->d_func()->layout) {
             layout->widgetEvent(e);
         }
+    } else {
+        if (e->type() == QEvent::KeyPress)
+            qDebug()  << Q_FUNC_INFO <<receiver << "KEY";
+
     }
 
     // send to all receiver event filters
diff --git a/src/widgets/kernel/qwidgetwindow.cpp b/src/widgets/kernel/qwidgetwindow.cpp
index 78d6a29..27ab339 100644
--- a/src/widgets/kernel/qwidgetwindow.cpp
+++ b/src/widgets/kernel/qwidgetwindow.cpp
@@ -404,6 +404,7 @@ void QWidgetWindow::handleTouchEvent(QTouchEvent *event)
 
 void QWidgetWindow::handleKeyEvent(QKeyEvent *event)
 {
+    qDebug() << Q_FUNC_INFO << '>' << event->text();
     if (QApplicationPrivate::instance()->modalState() && !qt_try_modal(m_widget, event->type()))
         return;
 
@@ -417,7 +418,11 @@ void QWidgetWindow::handleKeyEvent(QKeyEvent *event)
         receiver = QWidget::keyboardGrabber();
     if (!receiver)
         receiver = focusObject();
-    QGuiApplication::sendSpontaneousEvent(receiver, event);
+    qDebug() << Q_FUNC_INFO << receiver << event->text() << "press "
+             << (event->type() == QEvent::KeyPress)
+             << "Calling QGuiApplication::sendSpontaneousEvent";
+    bool rc = QGuiApplication::sendSpontaneousEvent(receiver, event);
+    qDebug() << Q_FUNC_INFO << receiver << rc << "Done Calling QGuiApplication::sendSpontaneousEvent";
 }
 
 void QWidgetWindow::updateGeometry()
diff --git a/src/widgets/widgets/qabstractscrollarea.cpp b/src/widgets/widgets/qabstractscrollarea.cpp
index c277f7b..2fb48a3 100644
--- a/src/widgets/widgets/qabstractscrollarea.cpp
+++ b/src/widgets/widgets/qabstractscrollarea.cpp
@@ -966,6 +966,8 @@ bool QAbstractScrollArea::eventFilter(QObject *o, QEvent *e)
 */
 bool QAbstractScrollArea::event(QEvent *e)
 {
+    if (e->type() == QEvent::KeyPress)
+        qDebug() << this << Q_FUNC_INFO << '>' << e;
     Q_D(QAbstractScrollArea);
     switch (e->type()) {
     case QEvent::AcceptDropsChange:
diff --git a/src/widgets/widgets/qframe.cpp b/src/widgets/widgets/qframe.cpp
index 3697a2a..7605eb4 100644
--- a/src/widgets/widgets/qframe.cpp
+++ b/src/widgets/widgets/qframe.cpp
@@ -47,6 +47,7 @@
 #include "qstyle.h"
 #include "qstyleoption.h"
 #include "qapplication.h"
+#include "qdebug.h"
 
 #include "qframe_p.h"
 
@@ -529,6 +530,8 @@ void QFrame::changeEvent(QEvent *ev)
 /*! \reimp */
 bool QFrame::event(QEvent *e)
 {
+    if (e->type() == QEvent::KeyPress)
+        qDebug() << this << Q_FUNC_INFO << '>' << e;
     if (e->type() == QEvent::ParentChange)
         d_func()->updateFrameWidth();
     bool result = QWidget::event(e);
diff --git a/src/widgets/widgets/qplaintextedit.cpp b/src/widgets/widgets/qplaintextedit.cpp
index 992e613..142e9c8 100644
--- a/src/widgets/widgets/qplaintextedit.cpp
+++ b/src/widgets/widgets/qplaintextedit.cpp
@@ -1479,6 +1479,8 @@ void QPlainTextEdit::selectAll()
 bool QPlainTextEdit::event(QEvent *e)
 {
     Q_D(QPlainTextEdit);
+    if (e->type() == QEvent::KeyPress)
+        qDebug() << Q_FUNC_INFO << '>' << ((QKeyEvent *)(e))->text() << e->isAccepted();
 
 #ifndef QT_NO_CONTEXTMENU
     if (e->type() == QEvent::ContextMenu
@@ -1489,6 +1491,7 @@ bool QPlainTextEdit::event(QEvent *e)
         ce.setAccepted(e->isAccepted());
         const bool result = QAbstractScrollArea::event(&ce);
         e->setAccepted(ce.isAccepted());
+        qDebug() << Q_FUNC_INFO << "CTC" << e->isAccepted();
         return result;
     }
 #endif // QT_NO_CONTEXTMENU
@@ -1527,7 +1530,10 @@ bool QPlainTextEdit::event(QEvent *e)
         return true;
     }
 #endif // QT_NO_GESTURES
+    if (e->type() == QEvent::KeyPress)
+        qDebug() << Q_FUNC_INFO << '<' << ((QKeyEvent *)(e))->text() << e->isAccepted();
     return QAbstractScrollArea::event(e);
+
 }
 
 /*! \internal
@@ -1606,9 +1612,10 @@ void QPlainTextEdit::setPlainText(const QString &text)
 */
 void QPlainTextEdit::keyPressEvent(QKeyEvent *e)
 {
+    qDebug() << Q_FUNC_INFO << e->text();
     Q_D(QPlainTextEdit);
 
-#ifdef QT_KEYPAD_NAVIGATION
+#ifdef QT_KEYPAD_NAVIGATION<<
     switch (e->key()) {
         case Qt::Key_Select:
             if (QApplication::keypadNavigationEnabled()) {
@@ -1643,6 +1650,7 @@ void QPlainTextEdit::keyPressEvent(QKeyEvent *e)
                         clear();
                     } else {
                         e->ignore();
+                        qDebug() << "RETURN keypadNavigationEnabled(";
                         return;
                     }
                 }
@@ -1666,6 +1674,7 @@ void QPlainTextEdit::keyPressEvent(QKeyEvent *e)
             return;
         }
     }
+    qDebug() << Q_FUNC_INFO << '1';
     if (tif & (Qt::TextSelectableByKeyboard | Qt::TextEditable)) {
         if (e == QKeySequence::MoveToPreviousPage) {
             e->accept();
@@ -1678,6 +1687,7 @@ void QPlainTextEdit::keyPressEvent(QKeyEvent *e)
         }
     }
 
+    qDebug() << Q_FUNC_INFO << '2';
     if (!(tif & Qt::TextEditable)) {
         switch (e->key()) {
             case Qt::Key_Space:
@@ -1702,10 +1712,12 @@ void QPlainTextEdit::keyPressEvent(QKeyEvent *e)
                     QAbstractScrollArea::keyPressEvent(e);
                 }
         }
+        qDebug() << "RETURN NO EDITING";
         return;
     }
 #endif // QT_NO_SHORTCUT
 
+    qDebug() << Q_FUNC_INFO  << "CALLING INTO CONTROL" << e->text();
     d->sendControlEvent(e);
 #ifdef QT_KEYPAD_NAVIGATION
     if (!e->isAccepted()) {
@@ -1754,6 +1766,7 @@ void QPlainTextEdit::keyPressEvent(QKeyEvent *e)
 */
 void QPlainTextEdit::keyReleaseEvent(QKeyEvent *e)
 {
+    qDebug() << __FUNCTION__ << e->text();
 #ifdef QT_KEYPAD_NAVIGATION
     Q_D(QPlainTextEdit);
     if (QApplication::keypadNavigationEnabled()) {
diff --git a/src/widgets/widgets/qwidgettextcontrol.cpp b/src/widgets/widgets/qwidgettextcontrol.cpp
index a2e8230..9114e68 100644
--- a/src/widgets/widgets/qwidgettextcontrol.cpp
+++ b/src/widgets/widgets/qwidgettextcontrol.cpp
@@ -881,7 +881,9 @@ void QWidgetTextControl::cut()
 
 void QWidgetTextControl::copy()
 {
+
     Q_D(QWidgetTextControl);
+    qDebug() << this << Q_FUNC_INFO;
     if (!d->cursor.hasSelection())
         return;
     QMimeData *data = createMimeDataFromSelection();
@@ -1181,6 +1183,7 @@ void QWidgetTextControl::setHtml(const QString &text)
 void QWidgetTextControlPrivate::keyPressEvent(QKeyEvent *e)
 {
     Q_Q(QWidgetTextControl);
+    qDebug() << q << Q_FUNC_INFO;
 #ifndef QT_NO_SHORTCUT
     if (e == QKeySequence::SelectAll) {
             e->accept();
@@ -1189,6 +1192,7 @@ void QWidgetTextControlPrivate::keyPressEvent(QKeyEvent *e)
     }
 #ifndef QT_NO_CLIPBOARD
     else if (e == QKeySequence::Copy) {
+            qDebug() << q << Q_FUNC_INFO;
             e->accept();
             q->copy();
             return;